*
* Shared format routine used by the various versions of "printf"
* Input: Y=output pointer, X=argument pointer
*
_format_ PSHX			Save argument pointer
	STY	?parm		Save output pointer
	LDY	,X		Get format string
* Process next character from format string
?1	LDAA	,Y		Get next char
	INY			Advance to next
	CMPA	#'%'		Format string?
	BEQ	?2		Yes, handle it
	LDX	?parm		Get output string
	STAA	,X		Write to output
	INX
	STX	?parm		Resave output pointer
	TSTA			All done?
	BNE	?1		No, keep going
	PULX			Restore arg pointer
	RTS
* Test for '-', left justify
?2	LDAA	,Y		Get next character
	LDAB	#' '		Assume space
	CMPA	#'-'		Left justify?
	BNE	?3		No, its OK
	ORAB	#%10000000	Set LJ bit
	INY			Advance format string
	LDAA	,Y		Get next char
?3	CMPA	#'0'		Zero fill?
	BNE	?4		No, its OK
	ORAB	#'0'		Convert to ZF
?4	STAB	?temp		Save for later
* Evaluate field width
	CLRB			Zero width
?5	LDAA	,Y		Get char
	SUBA	#'0'		Convert to BIN
	CMPA	#10		In range?
	BHS	?6		No, end of number
	INY			Advance pointer
	PSHA			Save for later
	LDAA	#10		X10 for decimal numbers
	MUL			Get new result
	TSX			Address stack
	ADDB	,X		Include result
	PULA			Restore char
	BRA	?5		And proceed
* Interpret the format specifier
?6	STAB	?temp+1		Save width
	PULX			Get ptr to args
	DEX			Backup
	DEX			Backup
	PSHX			Resave
	LDX	,X		Get argument value
	LDAA	,Y		Get char
	INY			Advance
	PSHY			Save format string
	LDY	?parm		Get output pointer
* 'b' Binary number
	LDAB	#2		Base 2
	CMPA	#'b'		Binary output?
	BEQ	?8		Yes, do it
* 'o' Octal number
	LDAB	#8		Base 8
	CMPA	#'o'		Octal output?
	BEQ	?8		Yes, do it
* 'x' Hexidecimal number
	LDAB	#16		Base 16
	CMPA	#'x'		Hex output?
	BEQ	?8		Yes, do it
* 'u' Unsigned number
	CMPA	#'u'		Unsigned output?
	BEQ	?7		Yes, do it
* 'd' Decimal number
	CMPA	#'d'		Decimal output?
	BNE	?20		No, try next
	PSHX			Save X
	PULA			Get in HIGH acc
	PULB			Get in LOW acc
	TSTA			Check for negative
	BPL	?7		No problems
	COMA			Complement high
	COMB			Complement low
	ADDD	#1		Get two's complement
	XGDX			And swap back
	LDAA	#'-'		Get negative output
	STAA	,Y		Write in output
	INY			Advance
	STY	?parm		Resave output ptr
	LDAB	?temp+1		Get length
	BEQ	?7		Free format, its OK
	DEC	?temp+1		Adjust length
?7	LDAB	#10		Base 10 output
* Output number in X using base in B
?8	CLRA			Zero count
	PSHA			Save marker
* Process value & stack digits
?9	PSHB			Save BASE
	PSHA			Save COUNT
	PULY			Y = count/base
	CLRA			D = base only
	XGDX			D=number, X=base
	IDIV			X=num/base, D=num%base
	ADDB	#'0'		Convert to ASCII
	CMPB	#'9'		In range?
	BLS	?10		Its OK
	ADDB	#7		Convert hex digits
?10	PSHB			Save new value
	XGDY			D = count/base
	INCA			Advance count
	CPX	#0		More digits?
	BNE	?9		Do them all
* Unpack digits into output buffer
	LDY	?parm		Restore output pointer
	JSR	?40		Left fill if necessary
?11	PULB			Get char from stack
	TSTB			End of string?
	BEQ	?12		No, its OK
	STAB	,Y		Write it out
	INY			Advance
	BRA	?11		And proceed
?12	TST	?temp		Left justify?
	BPL	?13		No, don't pad
	JSR	?50		Pad on right
?13	STY	?parm		Resave output pointer
	PULY			Restore format string
	JMP	?1		And proceed
* 's' string
?20	CMPA	#'s'		String output?
	BNE	?30		No, its not
	PSHX			Save pointer
	LDAA	#-1		Start count (always loop once)
?21	INCA			Advance count
	LDAB	,X		Get char
	INX			Advance ptr
	TSTB			End of string?
	BNE	?21		Get length
	PULX			Restore pointer
	JSR	?40		Left fill if necessary
?22	LDAB	,X		Get char
	BEQ	?12		End of string
	STAB	,Y		Write in output
	INX			Advance source
	INY			Advance dest
	BRA	?22		And proceed
* 'c' Character
?30	TAB			Copy charcter
	CMPA	#'c'		Character output
	BNE	?31		No, keep char
	XGDX			B = char
?31	LDAA	#1		Width = 1
	JSR	?40		Left fill if necessary
	STAB	,Y		Write in output
	INY			Advance output
	BRA	?12		And proceed
*
* Pad the field assuming width in A
*
?40	TST	?temp		Left justify?
	BMI	?54		Yes, Don't pad
?50	PSHX			Save X
	PSHB			Save B
	PSHA			Save A (count)
	LDAB	?temp+1		Fixed field?
	BEQ	?53		No, exit
	LDAA	?temp		Get fill char
	ANDA	#%00111111	Save char
	TSX			Address stack
?52	CMPB	,X		Over count?
	BLS	?53		Yes, exit
	STAA	,Y		Write in output
	INY			Advance output
	DECB			Reduce count
	BRA	?52		And proceed
?53	PULA			Restore A
	PULB			Restore B
	PULX			Restore X
?54	RTS
