*
* Test for an ASCII value
*
isascii	LDD	#$007F		Range to test
	BRA	?3		Perform test
*
* Test for alphanumeric character (0-9, A-Z, a-z)
*
isalnum	PULY			Y = return address
	BSR	isdigit		Is it a digit?
	BEQ	?2		No, try alphas
?1	JMP	,Y		Return to caller
*
* Test for alphabetic character (A-Z, a-z)
*
isalpha	PULY			Y = return address
?2	BSR	isupper		Uppercase?
	BNE	?1		Found it
	PSHY			Resave ret address
*
* Test for lowercase alphabetic character (a-z)
*
islower	LDD	#'az'		Range to test
	BRA	?3		Perform test
*
* Test for uppercase alphabetic character (A-Z)
*
isupper	LDD	#'AZ'		Range to test
	BRA	?3		Perform test
*
* Test for graphic (printable) character
*
isgraph	LDD	#$217E		Range to test
	BRA	?3		And proceed
*
* Test for hexidecimal digit
*
isxdigit PULY			Y = return address
	LDD	#'AF'		Range to test
	BSR	?3		Test it
	BNE	?1		Found it
	LDD	#'af'		Range to test
	BSR	?3		Test it
	BNE	?1		Found it
	PSHY			Restack ret address
*
* Test for an ASCII digit (0-9)
*
isdigit	LDD	#'09'		Range to test
* Test argument against range in A:B
?3	TSX			Address stack
	CMPA	3,X		Test LOWER limit
	BHI	?5		Failed, return FALSE
	CMPB	3,X		Test UPPER limit
	BLO	?5		Failed, return FALSE
* Test that upper byte of argument is zero
?4	LDAA	2,X		Get high byte
	BNE	?5		Non-zero, fail
	LDAB	#1		return 1
	RTS
* Report failure, return FALSE (0)
?5	CLRA			Zero HIGH
	CLRB			Zero LOW
	RTS
*
* Test for CONTROL character
*
iscntrl	TSX			Address stack
	LDAB	3,X		Get argument
	CMPB	#$7F		Delete?
	BEQ	?4		Yes, test high
	LDD	#$001F		CTRL-range
	BRA	?3		Complete test
*
* Test for a punctuation character
*
ispunct	TSX			Address stack
	LDD	2,X		Get argument
	PSHB			Pass LOW byte
	PSHA			Pass HIGH byte
	BSR	isalnum		Alphanumeric?
	INS			Clean up
	INS			Clean up
	BNE	?5		Yes, false
*
* Test for printable character
*
isprint	LDD	#$207E		Printable range
	BRA	?3		And test for it
*
* Test for a "space" character
*
isspace	TSX			Address stack
	LDAB	3,X		Get argument
	CMPB	#' '		Space?
	BEQ	?4		Seems OK
	CMPB	#9		Tab?
	BEQ	?4		Seems OK
	CMPB	#10		Newline?
	BEQ	?4		Seems OK
	BRA	?5		Invalid
