*
* Allocate a block of memory: char *malloc(size)
*
malloc	LDY	#?heap		Point to beginning of heap
* Search for free block of memory
?1	LDAA	,Y		Get allocation flag
	BEQ	?4		End of heap, allocate here
	DECA			Un-allocated?
	BNE	?2		No, try next
* Found a free block, see if it is large enough
	LDD	1,Y		Get block size
	TSX			Address stack
	SUBD	2,X		Large enough?
	BHS	?3		Yes, allocate here
* Block not suitable, advance to next
?2	PSHY			Save 'Y'
	PULA			Get high byte in ACC
	PULB			Get low byte in ACC
	ADDD	#3		Adjust for overhead
	ADDD	1,Y		Offset to next block
	XGDY			Set address back
	BRA	?1		And try again
* This block is OK to re-allocate
?3	SUBD	#3		Convert for overhead
	BLS	?6		Not enough space, leave alone
	STD	?temp		Save for later
* Split this block into two blocks
	PSHY			Save our pointer
	XGDY			Get address for math
	ADDD	2,X		Get block size
	XGDX			X = next block pointer
	CLR	3,X		Set it free
	INC	3,X		Indicate de-allocated
	LDD	?temp		Get block size
	STD	4,X		Save size of
	PULY			Restore our pointer
	BRA	?5		And proceed
* Allocate on end of memory
?4	TSX			X = stack address
	XGDX			D = stack address
	TSX			X = stack address (again)
	SUBD	2,X		Adjust for buffer size
	SUBD	#1000		Adjust for margin
	STY	?temp		Save for test
	CPD	?temp		Enough free space?
	BLS	?7		No, fail
* OK to proceed, allocate memory
	LDD	2,X		Get size
	ADDD	?temp		Offset to area
	XGDX			X = end address
	CLR	3,X		Indicate end of list
?5	TSX			Address stack
	LDD	2,X		Get size of parm
	STD	1,Y		Save pointer
?6	LDAB	#2		Get 'allocated' flag
	STAB	,Y		Set it
	XGDY			D = address
	ADDD	#3		Offset to data
	RTS
* Unable to allocate - failure
?7	CLRA			Zero high
	CLRB			Zero low
	RTS
*
* Release a block of memory: free(ptr)
*
free	TSX			Address stack
	LDX	2,X		Get address
	DEX			Backup
	DEX			to real
	DEX			beginning
	STX	?temp		Save for later compare
* Search allocation lst for this block
	LDX	#?heap		Point to beginning of heap
?10	LDAA	,X		Get address
	BEQ	?12		End of list
	CPX	?temp		Is this it?
	BEQ	?11		Yes, handle it
	PSHX			Save 'X'
	PULA			Get HIGH in ACC
	PULB			Get LOW in ACC
	ADDD	1,X		Include size
	ADDD	#3		Adjust for overhead
	XGDX			Set address back
	BRA	?10		And keep looking
* Mark this block as un-allocated
?11	LDAB	#1		Get 'de-allocated' flag
	STAB	,X		Save it
* Garbage collection, scan allocation list and join any
* condiguous de-allocated blocks into single areas.
* Also, truncate list at last allocated block
?12	LDY	#?heap		Point to list
?20	LDAA	,Y		Get allocation flag
	BEQ	?25		End of table, quit
	DECA			Allocated?
	BNE	?23		Yes, skip to next
	LDD	1,Y		Get initial block size
* This block is free, check following blocks
?21	STD	?temp		Save current offset
	PSHY			Save base address
	PULX			X = base address
	XGDX			D = base address
	ADDD	?temp		Offset to current block
	XGDX			X = next block address
	LDAA	3,X		Get allocation flag
	BEQ	?24		End of list
	DECA			Allocated?
	BNE	?22		Yes, stop scanning
* Next block is also free (keep scanning)
	LDD	?temp		Get offset
	ADDD	4,X		Include new block
	ADDD	#3		Include overhead
	BRA	?21		And proceed
* Resave this block size
?22	LDD	?temp		Get size
	STD	1,Y		Set new block size
* Advance to next block in list
?23	PSHY			Save current address
	PULA			Get HIGH in ACC
	PULB			Get LOW in ACC (D=address)
	ADDD	1,Y		Offset by block size
	ADDD	#3		Adjust for overhead
	XGDY			Set new address
	BRA	?20		And proceed
* Mark this block as end of list
?24	CLR	,Y		Zero list
?25	RTS
